
// rf95_server.pde
// -*- mode: C++ -*-
// Example sketch showing how to create a simple messageing server
// with the RH_RF95 class. RH_RF95 class does not provide for addressing or
// reliability, so you should only use RH_RF95  if you do not need the higher
// level messaging abilities.
// It is designed to work with the other example rf95_client
// Tested with Anarduino MiniWirelessLoRa, Rocket Scream Mini Ultra Pro with
// the RFM95W, Adafruit Feather M0 with RFM95
#define BLYNK_PRINT Serial


#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <SPI.h>
#include <RH_RF95.h>


// Singleton instance of the radio driver
RH_RF95 rf95(15,4);

//Blynk auth token
char auth[] = "YourAuthToken";

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "YourUsername";
char pass[] = "YourPassword";
int pinValue = 0;
int count = 0;
// Structure for receiving location
struct Location{      
  float latitude = 0;
  float longitude = 0;
  int satellite = 0;};
Location locatin;    
WidgetMap myMap(V0);
BLYNK_WRITE(V6)
{
 pinValue = param.asInt(); // assigning incoming value from pin V1 to a variable

  
}


void setup() 
{    
  Serial.begin(9600);
  if (!rf95.init())
    Serial.println("init failed");  
  
  Blynk.begin(auth, ssid, pass);

}

void loop()
{ Blynk.run();
  if (rf95.available())
  {
  if(pinValue == 1)
  {
  
    // Should be a message for us now   
    uint8_t buf[sizeof(locatin)];
    uint8_t len = sizeof(buf);
    if (rf95.recv((uint8_t*)&locatin, &len))
    {
      
//      RH_RF95::printBuffer("request: ", buf, len);
     
      Serial.print(" ");
      Serial.print(rf95.lastRssi(), DEC);
      Serial.print("  ");
      Serial.print(locatin.latitude, 6);
      Serial.print(",");
      Serial.print(locatin.longitude,6);
      Serial.println();
      Blynk.virtualWrite(V1, String(locatin.latitude, 6));
      Blynk.virtualWrite(V2, String(locatin.longitude,6));
      Blynk.virtualWrite(V3, rf95.lastRssi()); 
      Blynk.virtualWrite(V4, count);
      count++;//  added to check on the data flow
      int index = 0;
      myMap.location(index, String(locatin.latitude, 6), String(locatin.longitude,6), "value");
      // Send a reply
      uint8_t data[] = "active";
      rf95.send(data, sizeof(data));
      rf95.waitPacketSent();
      
       
    }
    else
    {
      Serial.println("recv failed");
    }
  }
  
  if(pinValue == 0)
  { 
     // Should be a message for us now   
    uint8_t buf[sizeof(locatin)];
    uint8_t len = sizeof(buf);
    if (rf95.recv((uint8_t*)&locatin, &len))
    {
      Serial.print("got request: ");
      Serial.println((char*)buf);
      Serial.print("RSSI: ");
      Serial.println(rf95.lastRssi(), DEC);
      
      // Send a reply
      uint8_t data[] = "stop";
      rf95.send(data, sizeof(data));
      rf95.waitPacketSent();
      Serial.println("Sent a reply");
      Blynk.virtualWrite(V1, 0);
      Blynk.virtualWrite(V2, 0);
      Blynk.virtualWrite(V4, 0);
      Blynk.virtualWrite(V3, rf95.lastRssi()); 
    }
    else
    {
      Serial.println("recv failed");
    }
  } 
  }
}
